/****************************************************************************/
/**    GNOM - Gnom Is NOt MCuT                                             **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Keyboard-Ansteuerung-Routinen                                         **/
/****************************************************************************/


#include "global.h"
#include "keyboard.h"

#include "toolbox.h"
#include "commands.h"
#include "sndqueue.h"
#include "display.h"





#define ANZ_TERMCMD 36
char TermCommands[ANZ_TERMCMD][20]={"QUIT",
                                    "SEND",
                                    "DISCONNECT",
                                    "NAME",
                                    "CONNECT",
                                    "REMOTE",
                                    "MYCALL",
                                    "SAVE",
                                    "CLOSE",
                                    "SENDABIN",
                                    "SYS",
                                    "SETTYPE",
                                    "COMP",
                                    "AUTOBIN",
                                    "AUTO7PLUS",
                                    "REDRAW",
                                    "COOKIE",
                                    "FRAMESIZE",
                                    "TEST",
                                    "PORTS",
                                    "PRIV",
                                    "CONVERT",
                                    "CBELL",
                                    "RING",
                                    "RTT",
                                    "CHANNEL",
                                    "FREECH",
                                    "SBIN",
                                    "AWAY",
                                    "600",
                                    "2M",
                                    "MONITOR",
                                    "CLOCK",
                                    "FORCE",
                                    "KLACK",
                                    "ABORT"};



/* Gibt einen 0-Terminierten String in der aktuellen Zeile der Vorschreibfensters aus. */
void ErrorText(char *str, int ret)
{
  if (sizeof(str)>80) str[81] = '\0';

  strcpy(chaninfo[AktChan]->vor_act->text,str);
  chaninfo[AktChan]->vor_act->len = strlen(str);

  mvwprintw(tx_win,y_akt,0,chaninfo[AktChan]->vor_act->text);
  wclrtoeol(tx_win);

  if (ret)
     ScrollDown_Vorschreib(TRUE);
  else
     wrefresh(tx_win);
}



/* Terminal-Kommando-Auswertung */
void TerminalCommand(char *command)
{
  int i,found=0,len;
  char str1[81],str2[81],params[81];
  
  if (strlen(command)==0) {
    sprintf(str1,"GNOM/Linux V%i.%i.%i (%s) by DG6VJ",MAJORLEVEL,MINORLEVEL,PATCHLEVEL,DATUM);
    ErrorText(str1,TRUE);
    return;
  }
  
  KillSpacesRight(command);
  
  /* Gucken, ob evtl. ein Parameter mitgegeben wurde */
  if ((i = POS(' ',command)) != -1)
  {
    COPY(params,command,i+1,strlen(command));
    command[i] = '\0';
    
    KillSpacesLeft(params);
  }
  else params[0] = '\0';
  
  Gross(command);
  len = strlen(command);
  
  i = 0;
  while (!found) {
    COPY(str1,command,0,len);
    COPY(str2,TermCommands[i],0,len);
    if (!strcmp(str1,str2))
       found = 1;
    else
       i++;
    if (i>ANZ_TERMCMD) found=1;
  }
  
  if (i>ANZ_TERMCMD) {
    ScrollDown_Vorschreib(TRUE);
    ErrorText("Invalid command",TRUE);
  }
  else {
    if (i<=ANZ_TERMCMD) {
      switch(i) {
        case  0: cmd_Quit(); break;			/* :QUIT */
        case  1: cmd_Send(params); break;		/* :SEND <filename> (Textfiles) */
        case  2: cmd_disc(); break;			/* :DISCONNECT */
        case  3: cmd_name(params); break;		/* :NAME <name> */
        case  4: cmd_connect(params); break;		/* :CONNECT <call> */
        case  5: cmd_remote(params); break;		/* :REMOTE [ON|OFF] */
        case  6: cmd_mycall(params); break;		/* :MYCALL <call> */
        case  7: cmd_save(params); break;		/* :SAVE <filename> */
        case  8: cmd_close(); break;			/* :CLOSE */
        case  9: cmd_Send_AutoBIN(params); break;	/* :SENDABIN <filename> */
        case 10: cmd_sys(); break;			/* :SYS */
        case 11: cmd_settype(params); break;		/* :SETTYPE */
        case 12: cmd_comp(params); break;		/* :COMP [ON|OFF] */
        case 13: cmd_autobin(params); break;		/* :AUTOBIN [ON|OFF] */
        case 14: cmd_auto7plus(params); break;		/* :AUTO7PLUS [ON|OFF] */
        case 15: cmd_redraw(); break;			/* :READRAW */
        case 16: cmd_cookie(); break;			/* :COOKIE */
        case 17: cmd_framesize(params); break;		/* :FRAMESIZE [<size>] */
        case 18: cmd_test(); break;
        case 19: cmd_ports(); break;			/* :PORTS */
        case 20: cmd_sys(); break;			/* :PRIV */
        case 21: cmd_convert(params); break;		/* :CONVERT <tx/rx> */
        case 22: cmd_cbell(params); break;		/* :CBELL [ON|OFF] */
        case 23: cmd_ring(params); break;		/* :RING [ON|OFF] */
        case 24: cmd_rtt(); break;			/* :RTT */
        case 25: cmd_channel(params); break;		/* :CHANNEL <ch-nr> */
        case 26: cmd_freech(); break;			/* :FREECH */
        case 27: cmd_Send_AutoBIN(params); break;	/* :SENDABIN <filename> */
        case 28: cmd_away(params); break;		/* :AWAY [<text>] */
        case 29: cmd_telefon(); break;			/* :600 */
        case 30: cmd_2m(); break;			/* :2M */
/*        case 31: cmd_monitor(params); break;*/		/* :MONITOR [ON|OFF] */
        case 32: cmd_clock(params); break;		/* :CLOCK */
        case 33: cmd_force(params); break;		/* :FORCE <//-Befehl> */
        case 34: cmd_klack(params); break;		/* :KLACK [ON|OFF] */
        case 35: cmd_abort(); break;			/* :ABORT */

      }
    }
  }
}



/* Tastatur einstellen */
void InitKeyboard()
{
  insert = 1;		/* Standard: Einfge-Modus */
  
  y_akt = tx_upper;
}


void Deinit_Keyboard()
{

}



/* AddChar - schreibt dieses Zeichen an die aktuelle Cursorposition im Vorschreibpuffer */
void AddChar(char ch)
{
  int i;
  s_vorschreib *vtmp;
  char str[100],tmp[100];

  /* Nur ein Zeichen dazu, wenn die Zeile noch nicht voll ist. */
  if (chaninfo[AktChan]->vor_act->len < 79) {
  
    if (insert) {
      i = chaninfo[AktChan]->vor_act->len;
      while (i >= x_akt)
      {
        chaninfo[AktChan]->vor_act->text[i+1] = chaninfo[AktChan]->vor_act->text[i];
        i--;
      }
      chaninfo[AktChan]->vor_act->len++;
    }
    else {
      if (x_akt == chaninfo[AktChan]->vor_act->len)
         chaninfo[AktChan]->vor_act->len++;
    }
    
    chaninfo[AktChan]->vor_act->text[x_akt] = ch;
    chaninfo[AktChan]->vor_act->text[chaninfo[AktChan]->vor_act->len] = '\0';
    x_akt++;
    
    if ((x_akt == chaninfo[AktChan]->umbruch) && (chaninfo[AktChan]->umbruch != 0))
    {
      /* Automatischer Zeilenumbruch */
      
      /* Position des letzten SPACEs 'raussuchen */
      i = lPOS(' ',chaninfo[AktChan]->vor_act->text);
      
      vtmp = chaninfo[AktChan]->vor_act->next;
      
      if (((vtmp->len == 0) || (chaninfo[AktChan]->vor_act == chaninfo[AktChan]->vor_lower)) && (i != -1))
      {
        COPY(str,chaninfo[AktChan]->vor_act->text,i+1,strlen(chaninfo[AktChan]->vor_act->text)-i-1);
        chaninfo[AktChan]->vor_act->len = i;
        chaninfo[AktChan]->vor_act->text[i] = '\0';
        
        /* Den String, der in die nchste Zeile kopiert wird, hier im Fenster lschen */
        wmove(tx_win,y_akt,chaninfo[AktChan]->vor_act->len);
        wclrtoeol(tx_win);
        
        /* Aussenden */
        sprintf(tmp,"%s\xD",chaninfo[AktChan]->vor_act->text);
        send_Textline(AktChan,tmp);
        
        /* Das briggebliebene Stck wird in die nchste Zeile gepackt */
        ScrollDown_Vorschreib(TRUE);
        strcpy(chaninfo[AktChan]->vor_act->text,str);
        chaninfo[AktChan]->vor_act->len = strlen(str);
        x_akt = strlen(str);
      }
    }
    
    /* Farben (Vorschreibfenster) setzen */
    wmove(tx_win,y_akt,0);
    waddstr(tx_win,chaninfo[AktChan]->vor_act->text);
    
    /* Cursor malen */
    wmove(tx_win,y_akt,x_akt);
    #ifdef slang
    refresh();
    #else
    redrawwin(tx_win);
    #endif
  }
}



/*
 * Auf die Tab-Taste wurde gedrckt
 */
void key_Tab()
{
  int newpos,anzspaces;
  
  newpos = (x_akt/config->tabsize)*config->tabsize+config->tabsize;
  if (newpos >= size_col) newpos = size_col-1;
  
  anzspaces = newpos-x_akt;
  
  while (anzspaces>0)
  {
    AddChar(' ');
    anzspaces--;
  }
}



void key_CursorRight()
{
  if (x_akt < size_col-1)
     if (x_akt < chaninfo[AktChan]->vor_act->len) {
       x_akt++;
        
       /* Cursor malen */
       wmove(tx_win,y_akt,x_akt);
       #ifdef slang
       refresh();
       #else
       redrawwin(tx_win);
       #endif
     }
}


void key_CursorLeft()
{
  if (x_akt > 0) {
    x_akt--;

    /* Cursor malen */
    wmove(tx_win,y_akt,x_akt);
    #ifdef slang
    refresh();
    #else
    redrawwin(tx_win);
    #endif
  }
}


void key_Home()
{
  if (x_akt != 0) {
    x_akt = 0;

    /* Cursor malen */
    wmove(tx_win,y_akt,x_akt);
    #ifdef slang
    refresh();
    #else
    redrawwin(tx_win);
    #endif
  }
}


void key_End()
{
  if (chaninfo[AktChan]->vor_act->len == 80)
     x_akt = 79;
  else
     x_akt = chaninfo[AktChan]->vor_act->len;

  /* Cursor malen */
  wmove(tx_win,y_akt,x_akt);
  #ifdef slang
  refresh();
  #else
  redrawwin(tx_win);
  #endif
}


/* Einfge- und berschreib-Mode umschalten */
void key_Insert()
{
  if (insert)
     insert = FALSE;
  else
     insert = TRUE;
  
  update_upper_statusline(TRUE);
}


/* Das Zeichen unter dem Cursor lschen */
void key_Delete()
{
  int i;
  
  if (x_akt < chaninfo[AktChan]->vor_act->len) {
    i = x_akt;
    while (i < chaninfo[AktChan]->vor_act->len-1) {
      chaninfo[AktChan]->vor_act->text[i] = chaninfo[AktChan]->vor_act->text[i+1];
      i++;
    }

    chaninfo[AktChan]->vor_act->len--;
    chaninfo[AktChan]->vor_act->text[chaninfo[AktChan]->vor_act->len] = '\0';

    wmove(tx_win,y_akt,0);
    waddstr(tx_win,chaninfo[AktChan]->vor_act->text);
    waddch(tx_win,' ');

    /* Cursor malen */
    wmove(tx_win,y_akt,x_akt);
    #ifdef slang
    refresh();
    #else
    redrawwin(tx_win);
    #endif
  }
}


void key_Backspace()
{
  int i;
  
  if (x_akt > 0) {
    i = x_akt-1;
    while (i < chaninfo[AktChan]->vor_act->len-1) {
      chaninfo[AktChan]->vor_act->text[i] = chaninfo[AktChan]->vor_act->text[i+1];
      i++;
    }

    chaninfo[AktChan]->vor_act->len--;
    chaninfo[AktChan]->vor_act->text[chaninfo[AktChan]->vor_act->len] = ' ';
    x_akt--;

    wmove(tx_win,y_akt,0);
    waddstr(tx_win,chaninfo[AktChan]->vor_act->text);
    waddch(tx_win,' ');

    /* Cursor malen */
    wmove(tx_win,y_akt,x_akt);
    #ifdef slang
    refresh();
    #else
    redrawwin(tx_win);
    #endif
  }
}



/* Einen weiter scrollen. Die einzelnen Daten werden nicht gendert. */
void ScrollDown_Vorschreib(int ret)
{
  int scroll=1;


  /* Erstmal im Speicher 'rumrdeln */

  if (chaninfo[AktChan]->vor_act == chaninfo[AktChan]->vor_lower) {
    /* Wir sind ganz unten angekommen */
    
    /* Wenn kein Return gedrckt wurde, nur weiter wandern, wenn in der Zeile
     * davor was steht.
     */
    if (ret || (!ret && (chaninfo[AktChan]->vor_act->len > 0))) {
      chaninfo[AktChan]->vor_act = chaninfo[AktChan]->vor_act->next;
      chaninfo[AktChan]->vor_lower = chaninfo[AktChan]->vor_lower->next;
      chaninfo[AktChan]->vor_upper = chaninfo[AktChan]->vor_upper->next;
      
      chaninfo[AktChan]->vor_act->len = 0;
      chaninfo[AktChan]->vor_act->text[0] = '\0';
    }
    else scroll=0;
  }
  else {
    /* Noch nicht ganz unten - "einfach" ein Listenfeld weiter */
    chaninfo[AktChan]->vor_act = chaninfo[AktChan]->vor_act->next;
  }
  
  
  /* Und jetzt die Anzeige auf dem Schirm - Scrollen oder nicht? */
  if (y_akt == tx_lower-tx_upper)
  {
    /* Wenn kein Return gedrckt wurde, nur dann Scrollen, wenn in der Zeile
     * davor was steht.
     */
    if (scroll) {
      /* Scrollen */
      wscrl(tx_win,1);
      wmove(tx_win,y_akt,0);
      waddstr(tx_win,chaninfo[AktChan]->vor_act->text);
      chaninfo[AktChan]->vor_screen = chaninfo[AktChan]->vor_screen->next;
    }
  }
  else {
    /* Noch nicht unten angekommen - einfach eine Zeile 'runter */
    y_akt++;
  }
  
  
  if (ret) {
    /* Beim Return: Am Anfang der Zeile den Cursor insetzen */
    x_akt = 0;
  }
  else {
    /* Ansonsten auf gleicher Hhe lassen, wenn der String so lang ist */
    if (chaninfo[AktChan]->vor_act->len < x_akt) x_akt = chaninfo[AktChan]->vor_act->len;
  }

  /* Cursor positionieren */
  wmove(tx_win,y_akt,x_akt);
  #ifdef slang
  refresh();
  #else
  redrawwin(tx_win);
  #endif
}



void ScrollUp_Vorschreib()
{

  /* Nur weiter wandern, wenn wir noch nicht ganz oben sind */
  if (chaninfo[AktChan]->vor_act != chaninfo[AktChan]->vor_upper) {
 
    /* Ein Listenfeld zurck (= hoch) */
    chaninfo[AktChan]->vor_act = chaninfo[AktChan]->vor_act->last;
  

    if (y_akt == 0) {
      /* Der Cursor ist ganz obem im Vorschreib-Feld -> hoch scrollen */
      wscrl(tx_win,-1);
      wmove(tx_win,0,0);
      waddstr(tx_win,chaninfo[AktChan]->vor_act->text);
      chaninfo[AktChan]->vor_screen = chaninfo[AktChan]->vor_screen->last;
    }
    else {
      /* Der Cursor ist noch nicht ganz oben - einfach eine Zeile hoch setzen */
      y_akt--;
    }

    /* Den Cursor auf gleicher Hhe lassen, wenn der String so lang ist */
    if (chaninfo[AktChan]->vor_act->len < x_akt) x_akt = chaninfo[AktChan]->vor_act->len;

    /* Cursor positionieren */
    wmove(tx_win,y_akt,x_akt);
    #ifdef slang
    #else
    redrawwin(tx_win);
    #endif
  }
}



void key_ChangeChannel(uchar chan)
{

  /* Wenn wir eh schon auf diesem Kanal sind, nix machen */
  if ((AktChan == chan) && (chancount<=10)) return;

  /* Auf dem alten Kanal im Scrollbuffer ganz nach Unten gehen */
  while (chaninfo[AktChan]->scroll_screen != chaninfo[AktChan]->scroll_screen_upper)
  {
     chaninfo[AktChan]->scroll_screen = chaninfo[AktChan]->scroll_screen->next;
  }

  /* Position des Cursors im Vorschreib-Puffers speichern */
  chaninfo[AktChan]->x_akt = x_akt;
  chaninfo[AktChan]->y_akt = y_akt;

  if (chancount <= 10)
  {
    /* Nur 10 Kanle - einfach */
    AktChan = chan;
  }
  else {
    /* Mehr als 10 Kanle, jetzt wirds schwierig, da jetzt der aktuelle Kanal mitspielt. */
    if (AktChan%10 == chan%10)
       AktChan = AktChan+10;			/* 10 Kanle hoch */
    else
       AktChan = chan + ((AktChan/10)*10);	/* Auf der aktuellen "ebene" herumwandern */
    
    if (AktChan > chancount) AktChan = chan;
  }

  /* Dieser Kanal hat keine neuen Infos mehr, da wir ja jetzt gerade gucken */
  chaninfo[AktChan]->flags &= ~CH_NEWDATA;

  /* Position des Cursors neu setzen */
  x_akt = chaninfo[AktChan]->x_akt;
  y_akt = chaninfo[AktChan]->y_akt;

  display_newscreen();
}



/* Keyboard-Verwaltung */
int DoKeyboard()
{

  int ch;
  char tmp[200];


  ch = wgetch(tx_win);

  switch (ConsoleStatus)
  {
    case 0: switch (ch)
            {
              case  9: key_Tab(); break;
              case 13: if (chaninfo[AktChan]->vor_act->text[0] == ':') {
                         strcpy(tmp,chaninfo[AktChan]->vor_act->text);
                         TerminalCommand(tmp+1);
                       }
                       else {
                         sprintf(tmp,"%s\xD",chaninfo[AktChan]->vor_act->text);
                         send_Textline(AktChan,tmp);
                         ScrollDown_Vorschreib(TRUE);
                       }
                       break;
              case 27: ch = wgetch(tx_win);
                       switch (ch)
                       {
                         case 'x':
                         case 'X': cmd_Quit(); break;	/* ESC / ALT-X - Quit */
                         case 'm':
                         case 'M': if (AktChan > 0)	/* ESC / ALT-M - Monitor */
                                      key_ChangeChannel(MONICHAN);
                                   break;
                         case 91: ch = wgetch(tx_win);
                                  switch (ch)
                                  {
                                    case 49: ch = wgetch(tx_win);
                                             if (ch == 126) key_Home();
                                             break;
                                    case 51: ch = wgetch(tx_win);
                                             if (ch == 126) key_Delete();
                                             break;
                                    case 52: ch = wgetch(tx_win);
                                             if (ch == 126) key_End();
                                             break;
                                  }
                                  break;
                       }
                       break;
              case KEY_LEFT: key_CursorLeft(); break;
              case KEY_RIGHT: key_CursorRight(); break;
              case KEY_DOWN: ScrollDown_Vorschreib(FALSE); break;
              case KEY_UP: ScrollUp_Vorschreib(); break;
              case 262: key_Home(); break;
              case 330: key_Delete(); break;
              case 331: key_Insert(); break;
              case 360: key_End(); break;
              case 338: display_ScrollUp(); break;
              case 339: display_ScrollDown(); break;
              case KEY_BACKSPACE: key_Backspace(); break;
              case 127: key_Backspace(); break;
              case KEY_F(1): key_ChangeChannel(1); break;
              case KEY_F(2): key_ChangeChannel(2); break;
              case KEY_F(3): key_ChangeChannel(3); break;
              case KEY_F(4): key_ChangeChannel(4); break;
              case KEY_F(5): key_ChangeChannel(5); break;
              case KEY_F(6): key_ChangeChannel(6); break;
              case KEY_F(7): key_ChangeChannel(7); break;
              case KEY_F(8): key_ChangeChannel(8); break;
              case KEY_F(9): key_ChangeChannel(9); break;
              case KEY_F(10): key_ChangeChannel(10); break;
              default: if (ch<256) AddChar(ch & 0xFF);
            }
            break;
    case 1: if ((ch == 'Y') || (ch == 'y')) return(0);
            if ((ch == 'N') || (ch == 'n'))
            {
              ConsoleStatus = 0;
              x_akt = 0;
              chaninfo[AktChan]->vor_act->text[0] = '\0';
              wmove(tx_win,y_akt,x_akt);
              wclrtoeol(tx_win);
              wmove(tx_win,y_akt,x_akt);
              wrefresh(tx_win);
            }
            break;
  }
  
  
  return(1);
}


