/****************************************************************************/
/**    GNOM - Gnom Is NOt MCuT                                             **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Funktionen zur Ansteuerung des Lautsprechers im Hintergrund, also     **/
/**  ohne das aktuell laufende Programm zu stren.                         **/
/****************************************************************************/

#include "global.h"
#include "speaker.h"

#include "toolbox.h"

#include <string.h>


char *savestr;
pid_t pid;


/* Eine bestimmte Anzahl Microsekunden warten */
void sleep_usec(int us)
{
  struct timeval tv;		/* fr die zeit beim select() */

  tv.tv_sec = 0;
  tv.tv_usec = us;
  select(0,NULL,NULL,NULL,&tv);
}



/*
 * speaker_playstring
 * Diese Funktion spielt den bergebenen String im Lautsprecher ab.
 *
 * Format: ton,laenge;ton,laenge;ton,laenge....
 *
 * Die Lnge in Milli-Sekunden
 */
void speaker_playstring(char *str)
{
  int ton,laenge,i;
  char tmp2[100],tmp3[100];

  /* Wenn ein Kindprozess terminiert nach ChildWait springen, da sonst
   * ein Zombie entstehen kann.
   */
/*  signal(SIGCHLD,(void *)ChildWait);*/


  if (fork() != 0) return;		/* Der Elternprozess darf schnell zurckkehren */
  
  /* Den bergebenen String sichern */
  savestr = (char *)strdup(str);
  
  while (savestr[0] != '\0')
  {
    if ((i = POS(';',savestr)) != -1)
    {
      COPY(tmp2,savestr,0,i);
      COPY(savestr,savestr,i+1,strlen(savestr)-i-1);
    }
    else
    {
      strcpy(tmp2,savestr);
      savestr[0] = '\0';
    }
    
    /* Sooo... Jetzt wird die Lnge und die Tonhhe auseinanderklamsert */
    if ((i = POS(',',tmp2)) != -1)	/* Nur wenn auch ein Komma vorkommt, wird der String gespielt. */
    {
      COPY(tmp3,tmp2,0,i);
      COPY(tmp2,tmp2,i+1,strlen(tmp2)-i-1);
      
      ton = atoi(tmp3);
      laenge = atoi(tmp2);
      
      if (laenge != 0)		/* Lnge ok? */
      {
        ioctl(0,KIOCSOUND,ton);
        sleep_usec(laenge*1000);
        ioctl(0,KIOCSOUND,0);
      }
    }
  }
  
  free(savestr);
  exit(3);
}



/*
 * Klackt einmal im Lautsprecher
 */
void speaker_klack()
{
  ioctl(0,KIOCSOUND,50);
  sleep_usec(1);
  ioctl(0,KIOCSOUND,0);
}


