/****************************************************************************/
/**  Diverse Routinen fr alle (meist mit Pascal-Namen, hi)  dg6vj, jun 96 **/
/**                                                                        **/
/** Copyright 1996,97 Jochen Sarrazin, DG6VJ. All rights reserved.         **/
/****************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <linux/ax25.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include "toolbox.h"
#include "string.h"


/* Kopiert 'count' Zeichen von 'src' nach 'dest' ab Position 'start'. 
   src und dest mssen 2 VERSCHIEDENE Strings sein! */
void COPY(char *dest, char *src, int start, int count)
{
  int from,to,i;

  i = 0;
  from = start;
  to = 0;
  while ((i<count) && (src[from]!='\0')) {
    dest[to] = src[from];
    i++;
    from++;
    to++;
  }
  dest[to] = '\0';
}



/* Wandelt alle Kleinbuchestaben in Grossbuchstaben um */
void Gross(char *str)
{
  int i;
  
  i=0;
  while (i<=strlen(str)) {
    if (((int)str[i]>=97) && ((int)str[i]<=122)) str[i] = str[i] - 32;
    i++;
  }
}



/* Wandelt alle Grossbuchestaben in Kleinbuchstaben um */
void Klein(char *str)
{
  int i;
  
  i=0;
  while (i<=strlen(str)) {
    if ((str[i]>='A') && (str[i]<='Z')) str[i] = str[i] + 32;
    i++;
  }
}



/* Wandelt einen Buchstaben in Grossbuchstaben um */
char upcase(char input)
{
  if ((input>=97) && (input<=122)) return(input-32);
  return(input);
}



/* Gibt die erste Position des Zeichens an, oder -1, wenn das Zeichen nicht in
   str ist */
int POS(char zeichen, char *str)
{
  int i,pos;
  
  i = 0;
  pos = -1;
  while ((str[i]!='\0') && (pos==-1)) {
    if (str[i]==zeichen) pos = i;
    i++;
  }
  
  return pos;
}



/* Gibt die letzte Position des Zeichens an, oder -1, wenn das Zeichen nicht in
   str ist */
int lPOS(char zeichen, char *str)
{
  int i,pos;
  
  i = strlen(str);
  pos = -1;
  while ((i >= 0) && (pos==-1)) {
    if (str[i]==zeichen) pos = i;
    i--;
  }
  
  return pos;
}



/* Schreibt das bergebene Zeichen anz mal in den dest-string */
void StringD(char *dest, int anz, char zeichen)
{
  int i=0;
  while (i<anz) {
    dest[i] = zeichen;
    i++;
  }
  dest[i] = '\0';
}


/* Vergleicht die beiden Strings. Rckgabe: 1, wenn gleich, 0 wenn nicht */
int strcompare(char *str1, char *str2)
{
  int i;
  
  /* Wenn die Stringlengen schon unterschiedlich sind, knnen die Strings
     selber schon nicht gleich sein */
  if (strlen(str1) != strlen(str2)) return(0);
  
  i = strlen(str1);
  while (i >= 0) {
    if (str1[i] != str2[i]) return(0);
    i--;
  }
  return(1);
}



/* Alle Leerzeichen links vom String lschen */
void KillSpacesLeft(char *str)
{
  int i=0,k=0;	/* anzahl leerzeichen */
  
  while ((str[i] != '\0') && (str[i] == ' ')) i++;
  if (str[i] == '\0') {
    str[0] = '\0';
    return;
  }
  
  /* Nur was machen, wenn sich auch was verndert hat */
  if (i>0) {
    while (str[i] != '\0') {
      str[k] = str[i];
      k++;
      i++;
    }
    str[k] = '\0';
  }
}



/* Alle Leerzeichen rechts lschen */
void KillSpacesRight(char *str)
{
  int i;
  
  i = strlen(str)-1;
  if (i < 0) return;
  
  while ((i>0) && (str[i] == ' ')) i--;
  str[i+1] = '\0';
}


/* Gre des bergebenen Files zurckgeben. Wenn nicht vorhanden wird -1 zurck gegeben. */
long filesize(char *filename)
{
  FILE *f;
  long i;
  
  f = fopen(filename,"r");
  
  if (f == NULL) return(-1);
  
  fseek(f,0,SEEK_END);
  i = ftell(f);
  fclose(f);
  
  return(i);
}


/* ALLE Leerzeichen in str lschen, und den sich dann ergebenen String nach tmp schreiben */
void KillAllSpaces(char *tmp, char *str)
{
  int i=0, k=0;
  
  while (str[i] != '\0') {
    if (str[i] != ' ') {
      tmp[k] = str[i];
      k++;
    }
    i++;
  }
  tmp[k] = '\0';
}


/* Wenn mehr als ein Leerzeichen nacheinander kommt, werden die brigen Leerzeichen
   gelscht. */
void OnlyOneSpace(char *tmp, char *str)
{
  int i=0,k=0,anz=0;
  
  while (str[i] != '\0') {
    if (str[i] != ' ') {
      tmp[k] = str[i];
      k++;
      anz = 0;
    }
    else {
      anz++;
      if (anz == 1) {
        tmp[k] = str[i];
        k++;
      }
    }
    
    i++;
  }
  tmp[k] = '\0';
}




/*
 * Lscht count Zeichen aus dem String str ab Position pos
 */
void delete(char *str, int pos, int count)
{
  int len;
  
  len = strlen(str);
  
  memmove(str+pos,str+pos+count,len-count);
  str[len-count] = '\0';
}


/*
 * Liest Zeichen bis zum nchsten vorkommen von sign aus dem File mit der bergebenen fd ein.
 *
 * Es findet KEINE berlaufprfung statt!
 */
int fdgets(int fd, char *str, char sign)
{
  char tmp[101];
  int count,count_wrote,ok,i,curpos;
  off_t startoffset;
  
  count_wrote = 0;
  
  str[0] = '\0';
  ok = 0;
  while (ok == 0) {
    /* Aktuellen Offset sichern */
    startoffset = lseek(fd,0,SEEK_CUR);
    count = read(fd,tmp,100);
    if (count != 100) ok = 1;
    /* An den Offset vor dem letzten Lesen springen */
    lseek(fd,startoffset,SEEK_SET);
    
    tmp[count] = '\0';
    if ((i = POS(sign,tmp)) == -1) {
      strcat(str,tmp);
    }
    else {
      tmp[i+1] = '\0';
      strcat(str,tmp);
      ok = 1;
    }
  }

  /* Den File-Zeiger neu positionieren */
  curpos = lseek(fd,strlen(str),SEEK_CUR);

  /* Gucken, ob wir am Ende des String sind */
  if (lseek(fd,0,SEEK_END) == curpos) return(-1);	/* Yo, am Ende */
  
  /* Nein, noch nicht am Ende */
  lseek(fd,curpos,SEEK_SET);
  return(0);
}



/* Wandelt den Integer-Wert in Hex-Zahlen um */
void int2hchar(int zahl, char *c1, char *c2)
{
  char hexzahl[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
  
  *c1 = hexzahl[zahl / 16];
  *c2 = hexzahl[zahl % 16];
}


/* Initialisierung der Random-Geschichte. */
void init_random()
{
  srand((int)time(NULL));
}



int file_exist(char *filename)
{
  int fd;
  
  if ((fd = open(filename,O_RDONLY)) == -1) {
    return(0);
  }
  else {
    close(fd);
    return(1);
  }
}



/********************************************************************************************/
/**  UTILITY - STUFF aus ax25d.c   Copyright (C) 1995 by Darryl L. Miles, G7LED.    *********/

/* Up to user to make sure 'h' is at least 'char h[AX25_CALLSID]' **/
char *ax25_ntoa(char *peer, const ax25_address *axa)
{
   const unsigned char *cp;
   unsigned char *h = (unsigned char *) peer;
   short cnt;

   for(cnt = 0, cp = (unsigned char *)axa; ; cnt++, cp++) {
      if(*cp == '\100')		/* Found a PAD char, skip the rest **/
         cnt = 5;
      else if(cnt < 6)		/* Callsign **/
         *h++ = *cp >> 1;
      else if(cnt == 6) {	/* SSID **/
         *h++ = '-';
         if((*cp & 0x1e) > 19) {
            *h++ = '1';
            *h++ = ((*cp & 0x1e) >> 1) + '&';
         } else {
            *h++ = ((*cp & 0x1e) >> 1) + '0';
         }
         *h = '\0';
         return peer;
      } 
   }
}

/* Should arg1 (char *h) really be 'const char *h' ?? **/
int ax25_aton(ax25_address *axa, const char *h)
{
   static const ax25_address ax25_empty = {
    { ' ' << 1, ' ' << 1, ' ' << 1, ' ' << 1, ' ' << 1, ' ' << 1, 0 }
   };
   short cnt;
   
   memcpy(axa, &ax25_empty, sizeof(ax25_address));

   for(cnt = 0; *h && isalnum(*h) && cnt < 6; cnt++, h++) {
      axa->ax25_call[cnt] = ((toupper(*h) << 1) & 0xff);
#if 0
      axa->ax25_call[cnt] = ((islower(*h) ? toupper(*h) << 1 : *h << 1) & 0xff);
#endif
   }
   
   if(*h && *h == '-') {
      cnt = atoi(++h);
      if(cnt < 0 || cnt > 15)
         cnt = 0;	/* should return 0/error or something **/
      axa->ax25_call[6] = (cnt << 1) & 0x1e; 
   }

   return sizeof(struct sockaddr_ax25);
}


/* Should arg1 (char *h) really be 'const char *h' ?? **/
int ax25_atonpath(struct full_sockaddr_ax25 *ax, const char *h)
{
   int addrlen, ndigis;
   char *cp, *tp, *line;
   
   if(!(line = (char *)strdup(h)))
      return 0;

   for(cp = line; *cp && isspace(*cp); cp++)
      ;
   for(tp = cp; *cp && !isspace(*cp); cp++)
      ;
   if(*cp)
      *cp++ = '\0';
   if((addrlen = ax25_aton(&ax->fsa_ax25.sax25_call, tp)) == 0) {
      free(line);
      return 0;
   }
   ax->fsa_ax25.sax25_ndigis = 0;

   for(ndigis = 0; *cp && ndigis < AX25_MAX_DIGIS; ) {
      for( ; *cp && isspace(*cp); cp++)
         ;
      for(tp = cp; *cp && !isspace(*cp); cp++)
         ;
     if(*cp)
        *cp++ = '\0';
     if(*tp == '\0')
        break;
     
     if(ndigis == 0 && (!strcasecmp("V", tp) || !strcasecmp("VIA", tp)))
        continue;
     if(ax25_aton(&ax->fsa_digipeater[ndigis], tp) == 0) {
        free(line);
        return 0;
     }
     ax->fsa_ax25.sax25_ndigis++;
     addrlen = sizeof(struct full_sockaddr_ax25);
/*     addrlen += sizeof(ax25_address); - OLD Method **/
     ndigis++;
   }

   return addrlen;
}

/************ END ax25d.c - STUFF ***********************************************************/
/********************************************************************************************/



/* Kopiert einen Integer-Array in einen anderen */
void intcpy(int *dest, int *src, int count)
{
  int i=0;
  
  while (i < count)
  {
    dest[i] = src[i];
    i++;
  }
}

/*
unsigned long power(unsigned long k, unsigned long i)
{
  unsigned long answer=1;

  while (i > 0)
  {
    answer *= k;
    i--;
  }
  return(answer);
}


char *dec2bin(unsigned int dec)
{
  int i;
  char *back;
  
  back = (char *)malloc(70);
  back[0] = '\0';
  
  i = 0;
  while (i < 32)
  {
    if ((dec & power(2,i))==0)
       strcat(back,"0");
    else
       strcat(back,"1");
    i++;
  }
  
  return(back);
}

*/



/* Vergleicht 2 Strings.
 *
 * Rckgabe: TRUE wenn gleich, FALSE wenn verschieden.
 */
int compare_strings(char *str1, char *str2)
{
  int len,k=0;
  
  if (strlen(str1) != strlen(str2)) return(FALSE);
  
  len = strlen(str1);
  while (k < len)
  {
    if (str1[k] != str2[k]) return(FALSE);
    k++;
  }
  return(TRUE);
}



long get_freemem()
{
  int i;
  int free=0,cached=0;
  char tmp[250],tmp2[100],tmp3[100];
  FILE *fs;
  
  if ((fs = fopen("/proc/meminfo","r")) == NULL) return(-1);


  while (fgets(tmp,200,fs) != NULL)
  {
    if ((i = POS(':',tmp)) != -1)
    {
      COPY(tmp2,tmp,0,i);
      COPY(tmp3,tmp,i+1,strlen(tmp)-i-1);
      KillSpacesLeft(tmp3);
      KillSpacesRight(tmp2);
      if ((i = POS(' ',tmp3)) != -1)
      {
        tmp3[i] = '\0';
        
        Gross(tmp2);
        if (!strcmp(tmp2,"MEMFREE"))
           free = atoi(tmp3);
        else if (!strcmp(tmp2,"CACHED"))
                cached = atoi(tmp3);
      }
    }
  }
  
  
  fclose(fs);
  
  return(free+cached);
}



/*
 * Sucht in den ersten count Bytes in str nach search. In search darf kein 0-Byte
 * vorkommen. Zurckgegeben wird die Position von search in str.
 *
 * Ist es garnicht enthalten, wird -1 zurck gegeben.
 */
int memstr(char *str, char *search, int count)
{
  int i,searchlen;
  char *tmp;
  
  searchlen = strlen(search);
  tmp = (char *) malloc(searchlen+1);
  
  i = 0;
  while (i < count-searchlen+1)
  {
    COPY(tmp,str,i,searchlen);
    if (!strcmp(tmp,search))
    {
      free(tmp);
      return(i);
    }
    i++;
  }
  
  free(tmp);
  return(-1);
}


